// module kbthread.cpp
// Copyright Dr.E.Huckert 12-2010

#include "kbthread.h"

// ---------------------------------------------------------
// Constructor
// Creates a thread instance - does not start the thread!
KbThread::KbThread(HU_Q *piq, Mutex *pim,
                   HU_Q *poq, Mutex *pom) :
                  ThreadBase(piq, pim, poq, pom)
{
  this->threadId = 0;
  this->pTrace = NULL;
}

// ----------------------------------------------------------
void KbThread::setLogging(HU_TRACE *pt)
{
  this->pTrace = pt;
}

// ----------------------------------------------------
// thread worker routine
//void *threadWorker_kb(void *threadid)
DWORD WINAPI threadWorker_kb(void *param)
{
  int ret   = 0;
  int cRet;
  char msg[256];
  KbThread *pk;
  //
  // get a pointer the the KbThread instance
  pk = (KbThread *)param;
  //
  while (1)
  {
    ::Sleep(10);
    // 
    // are there commands in out input queue?
    msg[0] = 0;
    (pk->getInpMutex())->setlock();
    cRet = (pk->getInpQueue())->getNoEntries();
    if (cRet > 0)
    {
      // read the message in the input queue
      char *pCmd = (pk->getInpQueue())->get();
      ::strcpy(msg, pCmd);
      delete pCmd;
    }
    (pk->getInpMutex())->unlock();
    if (::strlen(msg) > 0)
    {
      if (::strncmp(msg, "exit", 4) == 0)
        // "exit" command detected - leave this loop
        // leave this thread!
        break;
    }
    //
    // any events on the keyboard?
    if (kbhit())
    {
      fgets(msg, sizeof(msg), stdin);
      if (pk->pTrace != NULL)
        pk->pTrace->trace("threadWorker_kb(): msg=", msg);
      // 
      // put the message just read into the queue for the main thread
      (pk->getOutMutex())->setlock();
      (pk->getOutQueue())->add(msg);
      (pk->getOutMutex())->unlock();
    }
  }   // end while (1)
  //
  if (pk->pTrace != NULL)
    pk->pTrace->trace("threadWorker_kb(): exiting");
  return (DWORD)ret;
}   // end threadWorker_kb()

// ---------------------------------------------------------
// create and start a thread
// Returns 0 if OK
int KbThread::createAndRun()
{
  int ret = 0;
  HANDLE hThread;
  // Start a thread that will read the DB queue and
  // execute the DB requests    
  hThread = CreateThread(NULL, 
                         (DWORD)(16L * 1024L),   // stack size in bytes      
                         threadWorker_kb,        // thread worker routine
                         this,                   // argument to be passed
                         0, 
                         &(this->threadId));
  if (this->pTrace != NULL)
      this->pTrace->trace("KbThread::createAndRun() ID=", (long)threadId);
  return ret;
}   // end KbThread::create()