// module threadbase.h
// Copyright Dr.E.Huckert 12-2010

#ifndef THREADBASE_DEFINED
#define THREADBASE_DEFINED

#include "windows.h"
#include "hu_q.h"
#include "mutex.h"
#include "hu_trace.h"

class ThreadBase
{
  private:
    HU_Q  *pInpQ;     // input queue
    Mutex *pInpM;
    HU_Q  *pOutQ;    // output queue
    Mutex *pOutM;
  protected:
    ThreadBase(HU_Q *piq, Mutex *pim, HU_Q *poq, Mutex *pom);
  public:
    HU_Q *getOutQueue()
    { return this->pOutQ; };
    Mutex *getOutMutex()
    { return this->pOutM; };
    HU_Q *getInpQueue()
    { return this->pInpQ; };
    Mutex *getInpMutex()
    { return this->pInpM; };
};
#endif
